package NumericalIntegration;

class Sinus extends Function
{
	public double Evaluate(double x)
	{
		return Math.sin(x);
	}
}

public class TestIntegratorComparison {
	
	public static void main(String[] args) {
		Integrator ir = new RectangleIntegrator(100);
		Integrator it = new TrapezoidalIntegrator(100);
		Integrator is = new SimpsonIntegrator(100);
		Integrator im = new MonteCarloIntegrator(100);
		Function sinus = new Sinus();		
		System.out.println("n Rechteck Trapez Simpson MonteCarlo");
		for (int n=1; n<=1024; n*=2)
		{
			ir.SetNumberPieces(n);
			it.SetNumberPieces(n);
			is.SetNumberPieces(n);
			im.SetNumberPieces(n);
			System.out.print(n);
			System.out.print(" "+ir.Integrate(sinus, 0, Math.PI));
			System.out.print(" "+it.Integrate(sinus, 0, Math.PI));
			System.out.print(" "+is.Integrate(sinus, 0, Math.PI));
			System.out.print(" "+im.Integrate(sinus, 0, Math.PI));
			System.out.println();	
		}
	}

}
