package hardyCross;


public abstract class Edge {
	private double flow;
	String id;

	
	public Edge( String Id, double initialFlow){ 
		flow = initialFlow;
		id = Id;
	}
	
	public void SetFlow(double Q){
		flow = Q;
	}
	
	public double Flow(){
		return flow;
	}
	
	public abstract double HeadLoss(double flow);
	
	public double HeadLossDerivative(double flow)
	{
		final double epsilon = 0.0000001;
		return (HeadLoss(flow + epsilon) - HeadLoss(flow))/epsilon;
	}
	
	public void print()
	{
		System.out.print("Edge " + id + ": Flow = " + Flow() + ", HeadLoss = " +HeadLoss(Flow())+ ". ");
	}
}
