package hardyCross;

import java.util.Vector;
public class Loop {

	public Vector<Edge> edges;
	public Vector<Integer> directions;
	
	public Loop()
	{
		edges = new Vector<Edge>(0);
		directions = new Vector<Integer>(0);
	}
	
	public void Add(Edge edge, int direction)
	{
		edges.addElement(edge);
		directions.addElement(direction);
	}
	
	public void print()
	{
		for (int i = 0; i < edges.size(); ++i)
		{
			edges.get(i).print();
			System.out.println("Direction: " + directions.get(i));
		}
	}
	
	public double HeadLoss()
	{ 
		double x = 0;
		for (int i = 0; i < edges.size(); ++i)
		{
			Edge edge = edges.get(i);
			x += directions.get(i) * edge.HeadLoss(edge.Flow());
		}
		return x;
	}
	
	public double HeadLossDerivative()
	{
		double x = 0;
		for (int i = 0; i < edges.size(); ++i)
		{
			Edge edge = edges.get(i);
			x += edge.HeadLossDerivative(edge.Flow());
		}
		return x;
	}
	
	public void ApplyDelta(double deltaFlow)
	{
		for (int i = 0; i < edges.size(); ++i)
		{
			Edge edge = edges.get(i);
			edge.SetFlow(edge.Flow() - directions.get(i)*deltaFlow);
		}		
	}
	
}
