package hardyCross;

public class Pipe extends Edge{
	double length;
	double diameter;
	double friction;
	double roughness;

	public Pipe(String id, double initialFlow, double Roughness)
	{
		super(id, initialFlow); // call constructor of Edge
		roughness = Roughness;
	}

	public Pipe(String id, double initialFlow, double Length, double Diameter, double FrictionFactor)
	{
		super(id, initialFlow); // call constructor of Edge
		length = Length;
		diameter = Diameter;
		friction = FrictionFactor;
		roughness = 8 * friction * length / 9.8 / Math.pow(diameter,5) / Math.PI / Math.PI;
	}

	public double HeadLoss(double flow) {
		return roughness * flow * flow;
	}
	
	public double HeadLossDerivative(double flow)
	{
		return 2*roughness * flow;
	}

	public void print() {
		super.print();
		System.out.println("Pipe with roughness = " + roughness);
	}
	
}
