package hardyCross;
import java.util.Vector;

public class Setup {
	public Vector<Loop> loops;
	public Vector<Edge> edges;

	public Setup()
	{
		loops = new Vector<Loop>(0);
		edges = new Vector<Edge>(0);
	}

	public Edge AddEdge(Edge edge)
	{
		edges.addElement(edge);
		return edge;
	}

	public Loop AddLoop(Loop loop)
	{
		loops.addElement(loop);
		return loop;
	}

	public void print()
	{
		System.out.println("Graph:");
		for (int i = 0; i<edges.size(); ++i)
			edges.get(i).print();
		/*for (int i = 0; i<loops.size(); ++i){
			System.out.println("loop " + i +":");
			loops.get(i).print();			
		}*/
	}

	public boolean compute(double accuracy)
	{
		final int maxNumIterations = 100;
		boolean done = false;
		for (int iter = 0; iter < maxNumIterations && !done ; ++iter)
		{
			done = true;
			for (int i = 0; i<loops.size(); ++i)
			{
				Loop loop = loops.get(i);
				double headLoss = loop.HeadLoss();
				double headLossDerivative = loop.HeadLossDerivative();
				double delta = headLoss/headLossDerivative;
				// System.out.println("loop "+ i + " headLoss = " + headLoss + "derivative = " + headLossDerivative + " delta = " + delta);
				loop.ApplyDelta(delta);
				if (Math.abs(loop.HeadLoss()) > accuracy) 
					done = false;
			}
		}
		return done;
	}
}
